package ch3.ex3;

import org.apache.axis.client.ServiceClient;
import org.apache.axis.message.SOAPEnvelope;
import org.apache.axis.message.SOAPHeader;
import org.apache.axis.message.RPCElement;
import org.apache.axis.message.RPCParam;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/*
 * Inventory check web service client
 */
public class InventoryCheckClient {
    /**
     * Service URL
     */
    String url;

    /**
     * Email address to send confirmations to
     */
    String email;
    
    /**
     * Point a client at a given service URL
     */
    public InventoryCheckClient(String url, String email) {
        this.url = url;
        this.email = email;
    }
    
    /**
     * Invoke the inventory check web service
     */
    public boolean doCheck(String sku, int quantity) throws Exception {
        // Build the email header DOM element
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        DocumentBuilder builder = factory.newDocumentBuilder();
        Document doc = builder.newDocument();
        Element emailElem = doc.createElementNS("http://www.skatestown.com/",
                                                "EMail");
        emailElem.appendChild(doc.createTextNode(email));

        // Build the RPC request SOAP message
        SOAPEnvelope reqEnv = new SOAPEnvelope();
        reqEnv.addHeader(new SOAPHeader(emailElem));
        Object[] params = new Object[]{ sku, new Integer(quantity), };
        reqEnv.addBodyElement(new RPCElement("", "doCheck", params));
        
        // Invoke the inventory check web service
        ServiceClient call = new ServiceClient(url);
        SOAPEnvelope respEnv = call.invoke(reqEnv);
        
        // Retrieve the response
        RPCElement respRPC = (RPCElement)respEnv.getFirstBody();
        RPCParam result = (RPCParam)respRPC.getParams().get(0);
        return ((Boolean)result.getValue()).booleanValue();
    }
}
