package ch5;

import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.io.ByteArrayOutputStream;
import sun.security.tools.KeyTool;
import javax.servlet.jsp.JspWriter;

final public class JavaRunner {
    private JavaRunner() {}

    public static void run(String cls, String[] args, JspWriter out)
        throws IOException
    {
        String[] javaArgs = new String[args.length + 2];
        javaArgs[0] = "java";
        javaArgs[1] = cls;
        System.arraycopy(args, 0, javaArgs, 2, args.length);

        Process proc = Runtime.getRuntime().exec(javaArgs);

        dump(proc.getInputStream(), out);

        try {
            proc.waitFor();
        } catch (InterruptedException e) {
        }
        if (proc.exitValue() != 0)
            dump(proc.getErrorStream(), out);
    }

    private static void dump(InputStream fromProc, JspWriter out)
        throws IOException
    {
        byte[] readBuf = new byte[2048];
        ByteArrayOutputStream bout = new ByteArrayOutputStream();
        int length;
        while ((length = fromProc.read(readBuf)) > 0)
            bout.write(readBuf, 0, length);
        bout.flush();

        String result = new String(bout.toByteArray());
        StringEncoder.encode(result, out);
        out.flush();
    }
}

