package ch5.ex1;

import java.io.InputStream;
import java.io.StringWriter;
import org.apache.axis.encoding.SerializationContext;
import org.apache.axis.message.SOAPEnvelope;
import org.apache.axis.message.SOAPBodyElement;
import org.apache.axis.client.ServiceClient;
import org.apache.axis.client.Transport;
import org.apache.axis.transport.http.HTTPTransport;
import org.apache.axis.Message;
import org.apache.axis.MessageContext;
import org.apache.axis.encoding.ServiceDescription;

public class POSubmission {
    String url;
    String uid;
    String password;

    public POSubmission(String url, String uid, String password) {
        this.url = url;

        // For HTTP Basic Authentication
        this.uid = uid;
        this.password = password;
    }

    public String invoke(InputStream po) throws Exception {
        ServiceClient client = new ServiceClient(url);

        // For HTTP Basic Authentication
        client.set(MessageContext.USERID, uid);
        client.set(MessageContext.PASSWORD, password);

        client.setRequestMessage(new Message(po, true));
        client.invoke();
        
        // Retrieve the response body
        MessageContext ctx = client.getMessageContext();
        Message outMsg = ctx.getResponseMessage();
        SOAPEnvelope envelope = outMsg.getAsSOAPEnvelope();
        SOAPBodyElement body = envelope.getFirstBody();
        
        // Get the XML from the body
        StringWriter w = new StringWriter();
        SerializationContext sc = new SerializationContext(w, ctx);
        body.output(sc);
        return w.toString();
    }
}
