package ch5.ex3;

import java.io.InputStream;
import java.io.StringWriter;
import org.apache.axis.encoding.SerializationContext;
import org.apache.axis.message.SOAPEnvelope;
import org.apache.axis.message.SOAPBodyElement;
import org.apache.axis.client.ServiceClient;
import org.apache.axis.client.Transport;
import org.apache.axis.transport.http.HTTPTransport;
import org.apache.axis.Message;
import org.apache.axis.MessageContext;
import org.apache.axis.encoding.ServiceDescription;

public class POSubmission {
    String url;
    String uid;
    String password;
    String storetype;
    String keystore;
    String storepass;

    public POSubmission(String url,
                        String uid,
                        String password,
                        String storetype,
                        String keystore,
                        String storepass)
    {
        this.url = url;

        // For HTTP Basic Authentication
        this.uid = uid;
        this.password = password;

        // For SSL
        this.storetype = storetype;
        this.keystore = keystore;
        this.storepass = storepass;
    }

    public String invoke(InputStream po) throws Exception {
        // For SSL
        String[][] props = {
            { "javax.net.ssl.trustStore", keystore, },
            { "javax.net.ssl.keyStore", keystore, },
            { "javax.net.ssl.keyStorePassword", storepass, },
            { "javax.net.ssl.keyStoreType", storetype, },
        };
        for (int i = 0; i < props.length; i++)
            System.getProperties().setProperty(props[i][0], props[i][1]);

        ServiceClient client = new ServiceClient(new HTTPTransport(url, null));

        // For HTTP Basic Authentication
        client.set(MessageContext.USERID, uid);
        client.set(MessageContext.PASSWORD, password);

        client.setRequestMessage(new Message(po, true));
        client.invoke();

        // Retrieve the response body
        MessageContext ctx = client.getMessageContext();
        Message outMsg = ctx.getResponseMessage();
        SOAPEnvelope envelope = outMsg.getAsSOAPEnvelope();
        SOAPBodyElement body = envelope.getFirstBody();

        // Get the XML from the body
        StringWriter w = new StringWriter();
        SerializationContext sc = new SerializationContext(w, ctx);
        body.output(sc);
        return w.toString();
    }
}
