package ch5.jms;

import org.apache.axis.AxisEngine;
import org.apache.axis.AxisFault;
import org.apache.axis.MessageContext;
import org.apache.axis.client.ServiceClient;
import org.apache.axis.client.Transport;
import org.apache.log4j.Category;

public class JMSTransport extends Transport {

    private String transportName = "jms";
    private String messageMode = null;
    private String factoryName = null;
    private String queueName = null;
    private String providerURL = null;
    private String icf = null;
    static Category category =
            Category.getInstance(JMSTransport.class.getName());

    public JMSTransport() {}

    public JMSTransport(String factoryName, String queueName) {
        this.factoryName = factoryName;
        this.queueName = queueName;
    }

    public void setFactory(String factoryName) {
        this.factoryName = factoryName;
    }

    public String getFactory() {
        return factoryName;
    }

    public void setQueue(String queueName) {
        this.queueName = queueName;
    }

    public String getQueue() {
        return queueName;
    }

    public void setContextFactory(String icf) {
        this.icf = icf;
    }

    public String getContextFactory() {
        return icf;
    }

    public void setProviderURL(String providerURL) {
        this.providerURL = providerURL;
    }

    public String getProviderURL() {
        return providerURL;
    }

    public void setupMessageContextImpl(MessageContext mc, ServiceClient serviceClient, AxisEngine engine)
            throws AxisFault
        {
        mc.setTransportName(transportName);
        /* Set properties in the message context so that JMSSender can obtain vital data
        required for initiating requests. */
        if (factoryName != null) mc.setProperty(JMSConstants.MC_JMS_FACTORY_NAME, factoryName);
        if (queueName != null) mc.setProperty(JMSConstants.MC_JMS_QUEUE_NAME, queueName);
        if (icf != null) mc.setProperty(JMSConstants.MC_JMS_INITIAL_CONTEXT_FACTORY, icf);
        if (providerURL != null) mc.setProperty(JMSConstants.MC_JMS_PROVIDER_URL, providerURL);
    }

}
