import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileNotFoundException;
import org.apache.axis.AxisFault;
import org.apache.axis.AxisEngine;
import org.apache.axis.server.AxisServer;
import org.apache.axis.Message;
import org.apache.axis.MessageContext;
import org.apache.axis.message.SOAPEnvelope;
import org.apache.axis.message.SOAPFaultElement;

public class FileListener {
    public void run() {
      while (true) {
        try {
          // Look for an incoming msg,create a new Message object
          FileInputStream input = new FileInputStream("inMsg");
          AxisEngine engine = AxisServer.getSingleton();
          MessageContext msgContext = new MessageContext(engine);
          Message msg = new Message(input);

          try {
            //Set it as the "request" message
            msgContext.setRequestMessage(msg);
  
            // Set the Transport
            msgContext.setTransportName("file");
    
            // Invoke the Axis engine
            engine.invoke(msgContext);
          }
          catch(Exception e) {
            // Catch any error and stick it in the response
            if (!(e instanceof AxisFault))
              e = new AxisFault(e);
            AxisFault af = (AxisFault)e;
            msg = msgContext.getResponseMessage();
            if (msg == null) {
                msgContext.setResponseMessage(new Message(af));
            } else {
                SOAPEnvelope env = msg.getAsSOAPEnvelope();
                env.clearBody();
                env.addBodyElement(new SOAPFaultElement(af));
            }
          }
       
          // Close and delete the incoming message
          input.close();
          (new File("inMsg")).delete();

          // Place the response message in a file called "outMsg"
          msg = msgContext.getResponseMessage();
          FileOutputStream output = new FileOutputStream("outMsg");
          String result = (String)msg.getAsString();
          output.write(result.getBytes());
          output.close();

          System.out.println("Processed a request");
        } catch(Exception exp) {
          if (!(exp instanceof FileNotFoundException))
            exp.printStackTrace();
        }
        // Sleep for a sec and then loop
        try {
          Thread.sleep( 1000 );
        } catch(Exception e) {
        }
      }
    }

    static public void main(String[] args) {
      (new FileListener()).run();
    }
}

